Subject: Re: [RE: [Megaco] Usage Of ContextId Wildcard]

From: Ian Leighton <[email-masked]>
Date: Wed, 03 Oct 2001 20:01:49 -0400

Hi Tom

I'am very sorry for the late reply.

I was referring to the NULL context.

I had not found any text which indicates that "only the terminations
matching the contextID are evaluated".

Regards
Ian Leighton

Tom-PT Taylor wrote:

>
>
> The quotation you consider so contradictory:
>
> > > "If the wildcard matches more than one TerminationID, all possible
>
> > > matches are attempted, with results reported for each one."
>
> is taken from command descriptions. A command is executed within an
> action.  The action has a contextID.  Only terminations matching that
> contextID are evaluated.  What contextID are you using there which
> causes the apparent contradiction with 6.1.1 and 8.1.2?
>
> -----Original Message-----
> From: Ian Leighton [mailto:[email-masked]]
> Sent: Tuesday, September 25, 2001 9:29 AM
> To: Christian Groves
> Cc: megaco ietf
> Subject: Re: [RE: [Megaco] Usage Of ContextId Wildcard]
>
> Hi Christian
>
> Why is there a reluctance to add clarifying text to the
> base document?
>
> Three comments below.
>
> Regards
> Ian
>
> Christian Groves wrote:
>
> > G'Day Ian,
> >
> > Perhaps I've been working with this for too long but I don't really
> see
> > the problems that led to the misinterpretation of this. If others on
> the
>
> > list want to add some more examples to 11.3 if it aids intepretation
> of
> > what is returned then OK.
>
> I don't think 11.3 is the best place unless the title is changed to
> indicate
> something other than Audit.
>
> >
> > Christian
> >
> > ..snip..
> > > The problem is not the individual statements but that statements
> contradict
> > >
> > > each other. Statements in 6.1.1and 8.1.2 (that indicate the ALL
> ContextID
> > > does not include NULL) are contradicted by the following statement
> in
> > > Add, Modify, Subtract, Move and AuditValue;
> > >
> > > "If the wildcard matches more than one TerminationID, all possible
>
> > > matches are attempted, with results reported for each one."
> > >
> > > In essence an implementor must choose which statement takes
> precedence;
> > >
> > > - do not include NULL in the reply because of what is stated in
> 6.1.1
> > > and 8.1.2 or
> > > - reply with NULL contextID because all terminations are checked
> and
> > > some of the matching terminations are in the NULL context.
> >
> > [CHG] I really don't see the contradiction. You match the
> terminations
> > that are in scope of the provided ContextID, in this case ALL which
> does
> > not contain the NULL context.
>
> If the above statement (ie "match the terminations that
> are in scope of the provided ContextID") existed in the
> spec I would agree with you..
>
> >
> > ..snip..
> >
> > > > 3) The ContextId's to use when multiple commands are present
> > > >    in an Action with ContextID = *.
> > > >
> > > > See above comment.
> > >
> > > For me this is the most troubling problem. Even if I take the
> above
> > > into consideration it appears to me that the following transaction
>
> > >
> > > t = 1 { c = $ { A = t1/1 {...}, Add = $ {...} }}
> > >
> > > could result in either of the following replies.
> > >
> > > p = 1 { c = 1 {A = t1/1 {...}}, c = 2 {A = ephem/1 {...}}}
> > > or
> > > p = 1 { c = 1 {A = t1/1 {...}, {A = ephem/1 {...}}}
> > >
> > > I believe that related problems exist for requests which include
> > > ContextId = * and AuditValue = T1/*,Subtract = *.
> > >
> > > I have not been able to find the reference but I recall a past
> > > email(s) which indicated that a requester should be concise
> > > in what is being requested. The current text can be interpreted
> > > 2 ways which makes being concise impossible when wildcard
> > > ContextId are involved. Unless I'm missing something, section
> > > 8.2.1 needs to be clarified to identify how wildcard contextId
> > > (ALL and CHOOSE) are processed especially when multiple
> > > commands are included in an action.
> > >
> > [CHG] It cannot be your first example, because you have requested to
>
> > CHoose "?" one context. The context scopes the rest of the commands
>
> > under it. I thought this was rather well understood.
>
> I whole heartedly agree that the second option is the
> correct one but this is not my point. The point is the spec
> could be interpreted as per example 1 because there is no
> statements which indicate the contextId resulting from the
> first command are used in subsequent commands.
>
> >
> >
> > _______________________________________________
> > Megaco mailing list
> > [email-masked]
> > http://www1.ietf.org/mailman/listinfo/megaco
>
> _______________________________________________
> Megaco mailing list
> [email-masked]
> http://www1.ietf.org/mailman/listinfo/megaco